diff -uNrd -x ChangeLog ircd-hybrid-7.0/include/channel.h PleXusIRCd-1.17a/include/channel.h
--- ircd-hybrid-7.0/include/channel.h	Fri Jan 31 18:00:25 2003
+++ PleXusIRCd-1.17a/include/channel.h	Thu Aug 21 01:23:52 2003
@@ -107,7 +107,7 @@
 #ifdef VCHANS
 extern void clear_channels(void *unused);
 #endif
-extern int     can_send (struct Channel *chptr, struct Client *who);
+extern int     can_send (struct Channel *chptr, struct Client *who, char *);
 extern int     is_banned (struct Channel *chptr, struct Client *who);
 
 extern int     can_join(struct Client *source_p, struct Channel *chptr,
@@ -155,6 +155,7 @@
 #define HoldChannel(x)          (!(x))
 /* channel visible */
 #define ShowChannel(v,c)        (PubChannel(c) || IsMember((v),(c)))
+#define ShowChannelOper(v,c)	(!PubChannel(c) || IsMember((v),(c)))
 
 #define IsMember(who, chan) ((who && who->user && \
                 dlinkFind(&who->user->channel, chan)) ? 1 : 0)
diff -uNrd -x ChangeLog ircd-hybrid-7.0/include/channel_mode.h PleXusIRCd-1.17a/include/channel_mode.h
--- ircd-hybrid-7.0/include/channel_mode.h	Mon Oct 28 16:09:20 2002
+++ PleXusIRCd-1.17a/include/channel_mode.h	Wed Aug 20 23:16:58 2003
@@ -100,6 +100,10 @@
 #define MODE_EXCEPTION  0x0800
 #define MODE_INVEX	0x2000
 #define MODE_HIDEOPS    0x4000
+#define MODE_BW         0x8000
+#define MODE_NOCOLOUR   0x10000
+#define MODE_REGONLY	0x20000
+#define MODE_OPERONLY   0x40000
 
 /*
  * mode flags which take another parameter (With PARAmeterS)
@@ -118,6 +122,9 @@
 #define ParanoidChannel(x)	((x) && ((x)->mode.mode &\
 			        (MODE_PRIVATE|MODE_INVITEONLY))==\
 		                (MODE_PRIVATE|MODE_INVITEONLY))
+
+#define BwChannel(x)            ((x) && ((x)->mode.mode & MODE_BW))
+#define NoColourChannel(x)       ((x) && ((x)->mode.mode & MODE_NOCOLOUR))
 
 struct ChModeChange
 {
diff -uNrd -x ChangeLog ircd-hybrid-7.0/include/client.h PleXusIRCd-1.17a/include/client.h
--- ircd-hybrid-7.0/include/client.h	Sun Feb 16 17:54:35 2003
+++ PleXusIRCd-1.17a/include/client.h	Tue Jun 17 21:03:08 2003
@@ -144,6 +144,7 @@
   unsigned int      umodes;     /* opers, normal users subset */
   unsigned int      flags;      /* client flags */
   unsigned int      flags2;     /* ugh. overflow */
+  unsigned long     svsid;      /* services ID if set */
 
   int               slink_pid;  /* pid of servlink process if any */
   int               hopcount;   /* number of servers to this 0 = local */
@@ -185,6 +186,12 @@
    * gcos field in /etc/passwd but anything can go here.
    */
   char              info[REALLEN + 1]; /* Free form additional client info */
+  /* 
+   * client->vhost is the vitual host that users get by default with umode +x
+   * if you want to change the presentation of the users host, do it here, and leave
+   * client->host alone
+   */
+  char             vhost[HOSTLEN +1];
 
 /* cache table of mappings between top level chan and sub vchan client
  * is on.
@@ -247,6 +254,8 @@
   unsigned short    sendB;      /* counters to count upto 1-k lots of bytes */
   unsigned short    receiveB;   /* sent and received. */
   unsigned int      lastrecvM;  /* to check for activity --Mika */
+  unsigned int      bwsavedB;  /* bw saved */
+  unsigned int      bwsavedK;  /* bw saved */
   int               priority;
   struct Listener*  listener;   /* listener accepted from */
   dlink_list        confs;      /* Configuration record associated */
@@ -418,11 +427,17 @@
 #define FLAGS_CALLERID     0x4000 /* block unless caller id's */
 #define FLAGS_UNAUTH       0x8000 /* show unauth connects here */
 #define FLAGS_LOCOPS       0x10000 /* show locops */
+#define FLAGS_HIDDEN       0x200000 /* +h hidden host */
+#define FLAGS_SERVICES     0x400000 /* +S Services mode */
+#define FLAGS_REG	   0x800000 /* +R for reged nicks */
 
 /* user information flags, only settable by remote mode or local oper */
 #define FLAGS_OPER         0x20000 /* Operator */
 #define FLAGS_ADMIN        0x40000 /* Admin on server */
 
+#define FLAGS_BW           0x80000 /* BW saving user mode */
+#define FLAGS_BOT          0x100000 /* BW saving bot mode */
+
 #define FLAGS_ALL	   FLAGS_SERVNOTICE
 
 
@@ -460,18 +475,21 @@
                                                * been ended. */
 
 #define SEND_UMODES  (FLAGS_INVISIBLE | FLAGS_OPER | FLAGS_WALLOP | \
-                      FLAGS_ADMIN)
+                      FLAGS_ADMIN | FLAGS_BW | FLAGS_HIDDEN | FLAGS_SERVICES | FLAGS_REG)
 #define ALL_UMODES   (SEND_UMODES | FLAGS_SERVNOTICE | FLAGS_CCONN | \
                       FLAGS_REJ | FLAGS_SKILL | FLAGS_FULL | FLAGS_SPY | \
                       FLAGS_NCHANGE | FLAGS_OPERWALL | FLAGS_DEBUG | \
                       FLAGS_BOTS | FLAGS_EXTERNAL | FLAGS_LOCOPS | \
- 		      FLAGS_ADMIN | FLAGS_UNAUTH | FLAGS_CALLERID)
+ 		      FLAGS_ADMIN | FLAGS_UNAUTH | FLAGS_CALLERID | FLAGS_BOT)
 
 #define FLAGS_ID     (FLAGS_NEEDID | FLAGS_GOTID)
 
 /*
  * flags macros.
  */
+#define IsReged(x)		((x)->flags & FLAGS_REG)
+#define SetReged(x)		((x)->flags |= FLAGS_REG)
+#define ClearReged(x)		((x)->flags &= ~FLAGS_REG)
 #define IsPerson(x)             (IsClient(x) && (x)->user)
 #define DoAccess(x)             ((x)->flags & FLAGS_CHKACCESS)
 #define IsDead(x)               ((x)->flags & FLAGS_DEADSOCKET)
@@ -519,6 +537,12 @@
 #define IsInvisible(x)          ((x)->umodes & FLAGS_INVISIBLE)
 #define SetInvisible(x)         ((x)->umodes |= FLAGS_INVISIBLE)
 #define ClearInvisible(x)       ((x)->umodes &= ~FLAGS_INVISIBLE)
+#define IsHidden(x)             ((x)->umodes & FLAGS_HIDDEN)
+#define SetHidden(x)            ((x)->umodes |= FLAGS_HIDDEN)
+#define ClearHidden(x)          ((x)->umodes &= ~FLAGS_HIDDEN)
+#define IsServices(x)           ((x)->umodes & FLAGS_SERVICES)
+#define SetServices(x)          ((x)->umodes |= FLAGS_SERVICES)
+#define ClearServices(x)        ((x)->umodes &= ~FLAGS_SERVICES)
 #define SendWallops(x)          ((x)->umodes & FLAGS_WALLOP)
 #define ClearWallops(x)         ((x)->umodes &= ~FLAGS_WALLOP)
 #define SendLocops(x)           ((x)->umodes & FLAGS_LOCOPS)
@@ -551,6 +575,11 @@
 
 #define SetGotId(x)             ((x)->flags |= FLAGS_GOTID)
 #define IsGotId(x)              (((x)->flags & FLAGS_GOTID) != 0)
+
+#define IsBwmode(x)             ((x)->umodes & FLAGS_BW)
+#define ClearBwmode(x)          ((x)->umodes &= ~FLAGS_BW)   
+#define IsBotmode(x)            ((x)->umodes & FLAGS_BOT)
+#define ClearBotmode(x)         ((x)->umodes &= ~FLAGS_BOT)
 
 /*
  * flags2 macros.
diff -uNrd -x ChangeLog ircd-hybrid-7.0/include/config.h PleXusIRCd-1.17a/include/config.h
--- ircd-hybrid-7.0/include/config.h	Thu Feb  6 03:46:11 2003
+++ PleXusIRCd-1.17a/include/config.h	Sat Oct 25 07:44:02 2003
@@ -180,7 +180,7 @@
  * We recommend you leave this undefined, and just take care with who you
  * give admin=yes; to.
  */
-#undef  HIDE_SERVERS_IPS
+#define  HIDE_SERVERS_IPS
 
 /* HIDE_SPOOF_IPS
  *
@@ -242,7 +242,7 @@
  * The number of messages that we can receive before we disconnect the
  * remote client...
  */
-#define CLIENT_FLOOD 20
+#define CLIENT_FLOOD 30
 
 /* NICKNAMEHISTORYLENGTH - size of WHOWAS array
  * this defines the length of the nickname history.  each time a user changes
@@ -296,8 +296,8 @@
  * If you have enabled efnet specific code these will be disabled automatically
  * else they are here for anyone else.
  */
-#define VCHANS
-#define ANONOPS
+#undef VCHANS
+#undef ANONOPS
 #define HALFOPS
 
 /*
@@ -360,7 +360,14 @@
  */
 #define INVARIANTS
 
+/* Name of Services for network if you plan on running some. */
+#define SERVICES "services.rizon.net"
+#define HOSTSERV "Acidictive.Rizon.net"
+
 #define CONFIG_H_LEVEL_7
+
+#define MODE_p_LOCK
+#define STAFF_HOSTMASK "staff.rizon.net"
 
 #include "defaults.h"
 #endif /* INCLUDED_config_h */
diff -uNrd -x ChangeLog ircd-hybrid-7.0/include/numeric.h PleXusIRCd-1.17a/include/numeric.h
--- ircd-hybrid-7.0/include/numeric.h	Wed Nov 27 10:46:24 2002
+++ PleXusIRCd-1.17a/include/numeric.h	Thu Jul 24 09:11:50 2003
@@ -214,13 +214,15 @@
 /*      RPL_WHOISSVCMSG      310         Dalnet */
 /*	RPL_WHOISHELPOP	     310	unreal */
 /*	RPL_WHOISSERVICE     310	austnet */
-
+#define RPL_WHOISREGNICK     307
 #define RPL_WHOISUSER        311
 #define RPL_WHOISSERVER      312
 #define RPL_WHOISOPERATOR    313
 
 #define RPL_WHOWASUSER       314
-/* rpl_endofwho below (315) */
+#define RPL_WHOISMODES       310
+#define RPL_WHOISVHOST       320
+/* rpl_endofwho below (320) */
 #define RPL_ENDOFWHOWAS      369
 
 #define RPL_WHOISCHANOP      316 /* redundant and not needed but reserved */
@@ -329,6 +331,7 @@
 #define ERR_NOMOTD           422
 #define ERR_NOADMININFO      423
 #define ERR_FILEERROR        424
+#define ERROR_SERVICESDOWN   425
 
 /* 	ERR_TOOMANYAWAY	     429	    Dalnet */
 
@@ -388,6 +391,7 @@
 #define ERR_MODELESS         477        /* ircu numeric -db */
 #define ERR_BANLISTFULL      478        /* I stole the numeric from ircu -db */
 #define ERR_BADCHANNAME      479
+#define ERR_REGNICKSONLY     480
 /* 	ERR_LINKFAIL	     479	unreal */
 /*	ERR_CANNOTKNOCK	     480	unreal */
 /*	ERR_NOULINE	     480	austnet */
diff -uNrd -x ChangeLog ircd-hybrid-7.0/include/patchlevel.h PleXusIRCd-1.17a/include/patchlevel.h
--- ircd-hybrid-7.0/include/patchlevel.h	Wed Jun 11 00:38:40 2003
+++ PleXusIRCd-1.17a/include/patchlevel.h	Fri Nov 28 05:27:48 2003
@@ -23,5 +23,7 @@
  */
 
 #ifndef PATCHLEVEL
-#define PATCHLEVEL   "hybrid-7.0"
+#define PATCHLEVEL PART1 PART2
 #endif
+#define PART1 "PleXusIRCd"
+#define PART2 "-1.17a"
diff -uNrd -x ChangeLog ircd-hybrid-7.0/include/s_gline.h PleXusIRCd-1.17a/include/s_gline.h
--- ircd-hybrid-7.0/include/s_gline.h	Fri May 24 19:34:08 2002
+++ PleXusIRCd-1.17a/include/s_gline.h	Wed Jun 25 02:47:30 2003
@@ -36,7 +36,7 @@
 extern int    remove_gline_match(const char *user, const char *host);
 extern void   cleanup_glines();
 extern void   add_gline(struct ConfItem *);
-
+extern void  send_glines(struct Client *client_p);
 
 typedef struct gline_pending
 {
diff -uNrd -x ChangeLog ircd-hybrid-7.0/include/s_serv.h PleXusIRCd-1.17a/include/s_serv.h
--- ircd-hybrid-7.0/include/s_serv.h	Mon Jun  9 22:16:52 2003
+++ PleXusIRCd-1.17a/include/s_serv.h	Tue Aug 26 07:55:58 2003
@@ -225,6 +225,8 @@
 #define SLINKRPL_ZIPSTATS       2
 
 #define MAX_SLINKRPL            2
+#define ZERO			231
+#define TAGGED			"PleXusIRCd"
 
 typedef void SlinkRplHnd(unsigned int replyid, unsigned int datalen,
                          unsigned char *data, struct Client *client_p);
diff -uNrd -x ChangeLog ircd-hybrid-7.0/include/s_stats.h PleXusIRCd-1.17a/include/s_stats.h
--- ircd-hybrid-7.0/include/s_stats.h	Wed Sep  4 21:30:07 2002
+++ PleXusIRCd-1.17a/include/s_stats.h	Tue Aug 26 06:34:46 2003
@@ -26,9 +26,14 @@
 #define INCLUDED_s_stats_h
 
 #include "config.h"
+#include "patchlevel.h"
 
 struct Client;
 
+  long        bwsavedB;        /* bw saved B */
+  long        bwsavedK;        /* bw saved K */
+
+#define STRUCT_COMP PART1
 /*
  * statistics structures
  */
@@ -59,6 +64,9 @@
   unsigned int    is_kill; /* number of kills generated on collisions */
   unsigned int    is_asuc; /* successful auth requests */
   unsigned int    is_abad; /* bad auth requests */
+
+  unsigned int is_bwsavedB;  /* bw saved */
+  unsigned int is_bwsavedK;  /* bw saved */
 };
 
 extern struct ServerStatistics* ServerStats;
diff -uNrd -x ChangeLog ircd-hybrid-7.0/include/s_user.h PleXusIRCd-1.17a/include/s_user.h
--- ircd-hybrid-7.0/include/s_user.h	Fri May 24 19:34:08 2002
+++ PleXusIRCd-1.17a/include/s_user.h	Mon Jun 23 01:08:48 2003
@@ -34,7 +34,7 @@
 extern int   user_mode(struct Client* , struct Client* , int, char** );
 extern void  send_umode (struct Client* , struct Client* ,
                          int, int, char* );
-extern void  send_umode_out(struct Client* , struct Client* , int);
+extern void  send_umode_out(struct Client* , struct Client* , struct Client* , int);
 extern int   show_lusers(struct Client* source_p);
 extern int   register_local_user(struct Client* ,struct Client* ,
 				 char* ,char* );
@@ -44,7 +44,7 @@
 			   char* ,char *,char *,char *);
 
 extern int   do_remote_user(char* ,struct Client* ,struct Client*,
-			    char* ,char *,char *,char *,char *);
+			    char* ,char *,char *,char *,char *, unsigned int svsid);
 
 extern int   user_modes_from_c_to_bitmask[];
 extern void  show_isupport(struct Client *);
diff -uNrd -x ChangeLog ircd-hybrid-7.0/include/send.h PleXusIRCd-1.17a/include/send.h
--- ircd-hybrid-7.0/include/send.h	Fri Feb 14 18:01:49 2003
+++ PleXusIRCd-1.17a/include/send.h	Wed Aug 20 19:53:08 2003
@@ -62,10 +62,9 @@
 extern  void sendto_one_prefix(struct Client *, struct Client *,
                                const char *, ...) AFP(3, 4);
 
-extern  void sendto_common_channels_local(struct Client *,
-                                          int,
+extern  void sendto_common_channels_local(struct Client *,                       
                                           const char *,
-                                          ...) AFP(3, 4);
+                                          ...) AFP(2, 3);
 
 extern  void sendto_channel_local(int type, struct Channel *,
                                   const char *, ...) AFP(3, 4);
diff -uNrd -x ChangeLog ircd-hybrid-7.0/include/supported.h PleXusIRCd-1.17a/include/supported.h
--- ircd-hybrid-7.0/include/supported.h	Tue Jul 16 16:26:47 2002
+++ PleXusIRCd-1.17a/include/supported.h	Thu Jul 24 10:17:34 2003
@@ -64,7 +64,7 @@
                         ConfigChannel.use_halfops ? "(ohv)@%+" : "(ov)@+", \
                         ConfigChannel.use_except ? "e" : "", \
                         ConfigChannel.use_invex ? "I" : "", \
-                        "b,k,l,imnpst", \
+                        "b,k,l,imnpstZcR", \
                         ConfigChannel.use_anonops ? "a" : "", \
                         ServerInfo.network_name, CASEMAP
 
diff -uNrd -x ChangeLog ircd-hybrid-7.0/include/whowas.h PleXusIRCd-1.17a/include/whowas.h
--- ircd-hybrid-7.0/include/whowas.h	Thu Jun  6 15:28:50 2002
+++ PleXusIRCd-1.17a/include/whowas.h	Mon Jun 16 07:58:32 2003
@@ -49,6 +49,7 @@
   char name[NICKLEN + 1];
   char username[USERLEN + 1]; 
   char hostname[HOSTLEN + 1];
+  char vhostname[HOSTLEN + 1];
   const char* servername;
   char realname[REALLEN + 1];
   time_t logoff;
diff -uNrd -x ChangeLog ircd-hybrid-7.0/modules/core/m_kick.c PleXusIRCd-1.17a/modules/core/m_kick.c
--- ircd-hybrid-7.0/modules/core/m_kick.c	Sat Feb  1 15:12:24 2003
+++ PleXusIRCd-1.17a/modules/core/m_kick.c	Mon Jun 16 18:24:14 2003
@@ -226,7 +226,7 @@
 			       ":%s!%s@%s KICK %s %s :%s",
 			       source_p->name,
 			       source_p->username,
-			       source_p->host,
+			       source_p->vhost,
 			       name,
 			       who->name, comment);
 	}
@@ -237,7 +237,7 @@
 			       ":%s!%s@%s KICK %s %s :%s",
 			       source_p->name,
 			       source_p->username,
-			       source_p->host,
+			       source_p->vhost,
 			       name, who->name, comment);
 	}
 
diff -uNrd -x ChangeLog ircd-hybrid-7.0/modules/core/m_kill.c PleXusIRCd-1.17a/modules/core/m_kill.c
--- ircd-hybrid-7.0/modules/core/m_kill.c	Fri Feb 14 18:01:53 2003
+++ PleXusIRCd-1.17a/modules/core/m_kill.c	Fri Aug 22 07:33:08 2003
@@ -127,10 +127,21 @@
                  me.name, parv[0], target_p->name);
       return;
     }
-
+  if (IsServices(target_p)) {
+        sendto_realops_flags(FLAGS_ALL, L_ALL, "Attempted services kill. From %s (%s@%s), they will now be killed.", source_p->name, source_p->username, source_p->host);
+                     
+        //Reverse the kill
+        target_p = source_p;
+        reason = "Do not attempt to kill a Network Service!";
+  }
+     
+  if ( (IsOper(source_p) && !IsAdmin(source_p)) && (IsOper(target_p) || IsAdmin(target_p)) ) {  
+        sendto_one(source_p, form_str(ERR_NOPRIVILEGES), me.name, source_p->name);
+        return;
+  }
   if(MyConnect(target_p))
     sendto_one(target_p, ":%s!%s@%s KILL %s :%s", 
-	       source_p->name, source_p->username, source_p->host,
+	       source_p->name, source_p->username, source_p->vhost,
 	       target_p->name, reason);
 
   /* Do not change the format of this message.  There's no point in changing messages
@@ -254,7 +265,7 @@
     }
     else
       sendto_one(target_p, ":%s!%s@%s KILL %s :%s",
-		 source_p->name, source_p->username, source_p->host,
+		 source_p->name, source_p->username, source_p->vhost,
 		 target_p->name, reason);
   }
 
@@ -359,7 +370,7 @@
       {
         sendto_one(client_p, ":%s KILL %s :%s!%s!%s!%s (%s)",
                    source_p->name, user,
-                   me.name, source_p->host, source_p->username,
+                   me.name, source_p->vhost, source_p->username,
                    source_p->name, reason);
       }
     else
diff -uNrd -x ChangeLog ircd-hybrid-7.0/modules/core/m_message.c PleXusIRCd-1.17a/modules/core/m_message.c
--- ircd-hybrid-7.0/modules/core/m_message.c	Sun Apr  6 12:47:37 2003
+++ PleXusIRCd-1.17a/modules/core/m_message.c	Tue Sep  2 05:10:19 2003
@@ -477,7 +477,7 @@
   }
 
   /* chanops and voiced can flood their own channel with impunity */
-  if ((result = can_send(vchan, source_p)))
+  if ((result = can_send(vchan, source_p, text)))
   {
     if (result == CAN_SEND_OPV ||
         !flood_attack_channel(p_or_n, source_p, vchan, chname))
@@ -551,7 +551,7 @@
 
     sendto_channel_local_butone(source_p, type, vchan, ":%s!%s@%s %s %c%s :%s",
                                 source_p->name, source_p->username,
-                                source_p->host, command, c, chname, text);
+                                source_p->vhost, command, c, chname, text);
   }
   else
   {
@@ -561,7 +561,7 @@
      */
     sendto_channel_local(type, vchan, ":%s!%s@%s %s %c%s :%s",
                          source_p->name, source_p->username,
-                         source_p->host, command, c, chname, text);
+                         source_p->vhost, command, c, chname, text);
   }
 
   if (chptr->chname[0] == '&')
@@ -616,7 +616,7 @@
         sendto_one(target_p, ":%s!%s@%s %s %s :%s",
                    source_p->name,
                    source_p->username,
-                   source_p->host, command, target_p->name, text);
+                   source_p->vhost, command, target_p->name, text);
       }
       else
       {
@@ -635,9 +635,9 @@
                             source_p->name);
 
           sendto_one(target_p,
-                     ":%s NOTICE %s :*** Client %s is messaging you and you are +g",
+                     ":%s NOTICE %s :*** Client %s [%s@%s] is messaging you and you are +g",
                      me.name, target_p->name,
-                     get_client_name(source_p, HIDE_IP));
+                     source_p->name, source_p->username, source_p->vhost);
 
           target_p->localClient->last_caller_id_time = CurrentTime;
 
@@ -708,8 +708,9 @@
       if (target_p->localClient->flood_noticed == 0)
       {
         sendto_realops_flags(FLAGS_BOTS, L_ALL,
-                             "Possible Flooder %s on %s target: %s",
-                             get_client_name(source_p, HIDE_IP),
+                             "Possible Flooder %s [%s@%s] on %s target: %s",
+                             source_p->name, source_p->username,
+                             source_p->vhost,
                              source_p->user->server, target_p->name);
         target_p->localClient->flood_noticed = 1;
         /* add a bit of penalty */
@@ -763,8 +764,9 @@
       if (chptr->flood_noticed == 0)
       {
         sendto_realops_flags(FLAGS_BOTS, L_ALL,
-                             "Possible Flooder %s on %s target: %s",
-                             get_client_name(source_p, HIDE_IP),
+                             "Possible Flooder %s [%s@%s] on %s target: %s",
+                             source_p->name, source_p->username,
+                             source_p->vhost,
                              source_p->user->server, chptr->chname);
         chptr->flood_noticed = 1;
 
@@ -973,7 +975,7 @@
 	{
 	  if (!MyClient(c2ptr)) /* implies mine and an user */
 	    continue;
-	  if ((!host || match(host, c2ptr->host)) &&
+	  if ((!host || match(host, c2ptr->host) || match(host, c2ptr->vhost)) &&
 	      irccmp(user, c2ptr->username) == 0)
 	    {
 	      (*count)++;
